
#include <stdio.h>
#include <stdlib.h>

#define FPUTS	(void)fputs
#define FPUTC	(void)fputc

static void	Error(msg)
char		*msg;
{
	FPUTS(msg,stderr); FPUTC('\n',stderr); exit(1);
}

#define PATH_LEN	1024
#define FREAD(i,j,k,l)	fread(i,(size_t)(j),(size_t)(k),l)
#define FWRITE(i,j,k,l)	(void)fwrite(i,(size_t)(j),(size_t)(k),l)

int	main(argc,argv)
int	argc;
char	**argv;
{
	FILE	*IF,*OF;
	char	header[13],cm[256*3],path[PATH_LEN],buffer[256*3];
	int	code,bytes,images=0;

	if (argc!=3) Error("usage : gif_split GIF file_name_format");

	if (argv[1][0]=='-')
	    IF=stdin;
	else
	    if ((IF=fopen(argv[1],"rb"))==NULL) Error("GIF file not open.");

	if (FREAD(header,13,1,IF)!=1 ||
	    header[0]!='G' ||
	    header[1]!='I' ||
	    header[2]!='F' ||
	    header[3]!='8' ||
	   (header[4]!='7' && header[4]!='9') ||
	    header[5]!='a') Error("not a GIF file.");

	if (header[10]&128)
	    if (FREAD(cm,(1<<(header[10]&7)+1)*3,1,IF)!=1)
		Error("global colormap read error.");

	while ((code=fgetc(IF))!=';')
	    if (code==EOF)
		Error("unexpected end of file.");
	    else if (code==',') {
		(void)sprintf(path,argv[2],images++);
		if ((OF=fopen(path,"wb"))==NULL) {
		    FPUTS(path,stderr); Error(" : GIF file not stored.");
		}
		FWRITE(header,13,1,OF);
		if (header[10]&128) FWRITE(cm,(1<<(header[10]&7)+1)*3,1,OF);

		FPUTC(',',OF);

		if (FREAD(buffer,9,1,IF)!=1)
		    Error("image descriptor read error.");

		FWRITE(buffer,9,1,OF);

		if (buffer[8]&128) {
		    bytes=(1<<(buffer[8]&7)+1)*3;
		    if (FREAD(buffer,bytes,1,IF)!=1)
			Error("local colormap read error.");

		    FWRITE(buffer,bytes,1,OF);
		}
		if ((code=fgetc(IF))==EOF) Error("code size read error.");

		FPUTC(code,OF);

		while ((bytes=fgetc(IF))!=0) {
		    if (bytes==EOF || FREAD(buffer,bytes,1,IF)!=1)
			Error("raster data read error.");

		    FPUTC(bytes,OF); FWRITE(buffer,bytes,1,OF);
		}
		FPUTC(0,OF); FPUTC(';',OF); (void)fclose(OF);
	    }
	    else if (code=='!') {
		if (fgetc(IF)==EOF) Error("extension function read error.");

		while ((bytes=fgetc(IF))!=0)
		    if (bytes==EOF || FREAD(buffer,bytes,1,IF)!=1)
			Error("extension data read error.");
	    }
	    else
		Error("unknown extension introducer.");

	if (IF!=stdin) (void)fclose(IF);

	return 0;
}
