
#include <stdio.h>
#include <stdlib.h>
#include "stl.h"

static void	Abort(path,msg)
char		*path,*msg;
{
	fprintf(stderr,"%s : %s.\n",path,msg); exit(1);
}

static size_t	fWriteReverse(ptr,size,items,file)
unsigned char	*ptr;
size_t		size,items;
FILE		*file;
{
	unsigned char	*p,*h,*t,c;
	size_t		i,s=size-1;

	for (p=ptr, i=0; i<items; i++, p+=size)
	    for (h=p, t=p+s; h<t; h++, t--) {
		c=(*h); *h=(*t); *t=c;
	    }

	return fwrite(ptr,size,items,file);
}

#define IN	argv[1]
#define OUT	argv[2]

int	main(argc,argv)
int	argc;
char	**argv;
{
	FILE		*in,*out;
	STL		stl;
	int		idx,num;
	float		xyz[12];
	double		nx,ny,nz;
	unsigned short	us=0x1234;
	unsigned char	*uc=(unsigned char *)&us;
	size_t		(*fWrite)()=(*uc==(us&0xff))?fwrite:fWriteReverse;

	if (argc!=3) {
	    fputs("usage : stl_a2b ASCII_STL binary_STL\n",stderr); exit(1);
	}

	if (IN[0]=='-')
	    in=stdin;
	else
	    if ((in=fopen(IN,"rb"))==NULL) Abort(IN,"file not found");

	if (!SetUpSTL(&stl,in)) Abort(IN,"STL header read error");

	if (stl.type==STL_TYPE_BINARY)
	    fprintf(stderr,"%s : just a binary STL (warning).\n",IN);

	if ((out=fopen(OUT,"wb"))==NULL) Abort(OUT,"file not stored");

	for (idx=80+sizeof(num); idx>0; idx--) fputc(0,out);

	for (num=0; ScanSTL(&stl,xyz+3,xyz+ 4,xyz+ 5,
				 xyz+6,xyz+ 7,xyz+ 8,
				 xyz+9,xyz+10,xyz+11)>0; num++) {
	    CalcNormal((double)xyz[ 3],(double)xyz[ 4],(double)xyz[ 5],
		       (double)xyz[ 6],(double)xyz[ 7],(double)xyz[ 8],
		       (double)xyz[ 9],(double)xyz[10],(double)xyz[11],
		       &nx,&ny,&nz); xyz[0]=nx; xyz[1]=ny; xyz[2]=nz;
	    if ((*fWrite)(xyz,sizeof(*xyz),12,out)!=12 ||
		fputc(0,out)!=0 ||
		fputc(0,out)!=0)
		Abort(OUT,"STL facet data write error");
	}
	if (in!=stdin) fclose(in);

	if ((out=freopen(OUT,"rb+",out))==NULL ||
	    fseek(out,80L,SEEK_SET) ||
	    (*fWrite)(&num,sizeof(num),1,out)!=1)
	    Abort(OUT,"STL facet number write error");

	fclose(out);

	return 0;
}
