
#include <stdio.h>
#include <math.h>
#include "stl.h"

int	main(argc,argv)
int	argc;
char	**argv;
{
	FILE	*file;
	STL	stl;
	double	x,y,z,area,x10,y10,z10,x20,y20,z20,nx,ny,nz;
	int	num;
	float	x0,y0,z0,x1,y1,z1,x2,y2,z2;

	if (argc==1) {
	    fputs("usage : stl_chk STL_files\n",stderr); exit(1);
	}
	while (--argc>0) {
	    if (**(++argv)=='-')
		file=stdin;
	    else
		if ((file=fopen(*argv,"rb"))==NULL) {
		    fprintf(stderr,"%s : file not found.\n",*argv); continue;
		}

	    if (!SetUpSTL(&stl,file))
		fprintf(stderr,"%s : STL header read error.\n",*argv);
	    else {
		x=y=z=area=0.0;
		for (num=0; ScanSTL(&stl,&x0,&y0,&z0,
					 &x1,&y1,&z1,
					 &x2,&y2,&z2)>0; num++) {
		    x10=x1-x0; x20=x2-x0;
		    y10=y1-y0; y20=y2-y0;
		    z10=z1-z0; z20=z2-z0;
		    x+=(nx=y10*z20-z10*y20);
		    y+=(ny=z10*x20-x10*z20);
		    z+=(nz=x10*y20-y10*x20); area+=sqrt(nx*nx+ny*ny+nz*nz);
		}
		printf("%s\t%d\t%lf\t%lf\t%lf\t%lf\n",
		       *argv,num,x/2.0,y/2.0,z/2.0,area/2.0);
	    }
	    if (file!=stdin) fclose(file);
	}
	return 0;
}
