
#ifndef	STL_COLOR
#define STL_COLOR
#endif

#include <stdio.h>
#include <stdlib.h>
#include "stl.h"

static void	Abort(path,msg)
char		*path,*msg;
{
	fprintf(stderr,"%s : %s.\n",path,msg); exit(1);
}

static size_t	fWriteReverse(ptr,size,items,file)
unsigned char	*ptr;
size_t		size,items;
FILE		*file;
{
	unsigned char	*p,*h,*t,c;
	size_t		i,s=size-1;

	for (p=ptr, i=0; i<items; i++, p+=size)
	    for (h=p, t=p+s; h<t; h++, t--) {
		c=(*h); *h=(*t); *t=c;
	    }

	return fwrite(ptr,size,items,file);
}

#define ORG	argv[1]
#define NEW	argv[argc-1]

int	main(argc,argv)
int	argc;
char	**argv;
{
	FILE		*org,*new;
	STL		stl;
	int		R,G,B,idx,num;
	unsigned short	f,flag=0,us=0x1234;
	float		xyz[12];
	double		x,y,z;
	unsigned char	*uc=(unsigned char *)&us;
	size_t		(*fWrite)()=(*uc==(us&0xff))?fwrite:fWriteReverse;

	if (argc!=3 && argc!=6) {
	    fputs("usage : stl_color orgSTL {R G B} newSTL\n",stderr); exit(1);
	}
	if (ORG[0]=='-')
	    org=stdin;
	else
	    if ((org=fopen(ORG,"rb"))==NULL) Abort(ORG,"file not found");

	if (!SetUpSTL(&stl,org)) Abort(ORG,"STL header read error");

	if (argc!=3) {
	    if ((R=atoi(argv[2]))<0 || R>255 ||
		(G=atoi(argv[3]))<0 || G>255 ||
		(B=atoi(argv[4]))<0 || B>255) {
		fputs("bad surface color.\n",stderr); exit(1);
	    }
	    flag=(unsigned short)(32768|((R&248)<<7)|((G&248)<<2)|((B&248)>>3));
	}

	if ((new=fopen(NEW,"wb"))==NULL) Abort(NEW,"file not stored");

	for (idx=80+sizeof(num); idx>0; idx--) fputc(0,new);

	for (num=0; ScanSTL(&stl,xyz+3,xyz+ 4,xyz+ 5,
				 xyz+6,xyz+ 7,xyz+ 8,
				 xyz+9,xyz+10,xyz+11,&f)>0; num++) {
	    CalcNormal((double)xyz[3],(double)xyz[ 4],(double)xyz[ 5],
		       (double)xyz[6],(double)xyz[ 7],(double)xyz[ 8],
		       (double)xyz[9],(double)xyz[10],(double)xyz[11],&x,&y,&z);
	    xyz[0]=x; xyz[1]=y; xyz[2]=z;
	    if ((*fWrite)(xyz,sizeof(*xyz),12,new)!=12 ||
		(*fWrite)(&flag,sizeof(flag),1,new)!=1)
		Abort(NEW,"STL facet data write error");
	}
	if (org!=stdin) fclose(org);

	if ((new=freopen(NEW,"rb+",new))==NULL ||
	    fseek(new,80L,SEEK_SET) ||
	    (*fWrite)(&num,sizeof(num),1,new)!=1)
	    Abort(NEW,"STL facet number write error");

	fclose(new);

	return 0;
}
