
#ifndef	STL_COLOR
#define STL_COLOR
#endif

#include <stdio.h>
#include <math.h>
#include "stl.h"

#define SHORT	unsigned short
#define FLAGS	(1L<<(8*sizeof(SHORT)))

int	main(argc,argv)
int	argc;
char	**argv;
{
	FILE	*file;
	STL	stl;
	int	f,count[FLAGS];
	double	area[FLAGS],nx,ny,nz;
	float	x0,y0,z0,x1,y1,z1,x2,y2,z2;
	SHORT	flag;

	if (argc!=2) {
	    fputs("usage : stl_fc STL_file\n",stderr); exit(1);
	}
	if (argv[1][0]=='-')
	    file=stdin;
	else
	    if ((file=fopen(argv[1],"rb"))==NULL) {
		fprintf(stderr,"%s : STL file not found.\n",argv[1]); exit(1);
	    }

	if (!SetUpSTL(&stl,file)) {
	    fprintf(stderr,"%s : STL header read error.\n",argv[1]); exit(1);
	}
	for (f=0; f<FLAGS; f++) {
	    count[f]=0; area[f]=0.0;
	}
	while (ScanSTL(&stl,&x0,&y0,&z0,&x1,&y1,&z1,&x2,&y2,&z2,&flag)>0) {
	    ++count[flag];
	    x1-=x0; y1-=y0; z1-=z0;
	    x2-=x0; y2-=y0; z2-=z0;
	    nx=y1*z2-z1*y2; ny=z1*x2-x1*z2; nz=x1*y2-y1*x2;
	    area[flag]+=(sqrt(nx*nx+ny*ny+nz*nz)/2.0);
	}
	for (f=0; f<FLAGS; f++)
	    if (count[f]) {
		printf("%d\t",f);
		if (STL_COLOR_FLAG(f))
		    printf("%d\t%d\t%d\t",(int)(STL_COLOR_R(f)*255.0+0.5),
					  (int)(STL_COLOR_G(f)*255.0+0.5),
					  (int)(STL_COLOR_B(f)*255.0+0.5));

		printf("%d\t%lf\n",count[f],area[f]);
	    }

	return 0;
}
