
#include <stdio.h>
#include "stl.h"

int	main(argc,argv)
int	argc;
char	**argv;
{
	FILE	*file;
	STL	stl;
	int	num;
	float	x0,y0,z0,x1,y1,z1,x2,y2,z2,x3,y3,z3,x4,y4,z4;

	if (argc==1) {
	    fputs("usage : stl_nmm STL_files\n",stderr); exit(1);
	}
	while (--argc>0) {
	    if (**(++argv)=='-')
		file=stdin;
	    else
		if ((file=fopen(*argv,"rb"))==NULL) {
		    fprintf(stderr,"%s : file not found.\n",*argv); continue;
		}

	    if (!SetUpSTL(&stl,file))
		fprintf(stderr,"%s : STL header read error.\n",*argv);
	    else {
		for (num=0; ScanSTL(&stl,&x0,&y0,&z0,
					 &x1,&y1,&z1,
					 &x2,&y2,&z2)>0; num++) {
		    if (num==0) {
			x3=x4=x0; y3=y4=y0; z3=z4=z0;
		    }
		    else {
			if (x0<x3) x3=x0; if (x0>x4) x4=x0;
			if (y0<y3) y3=y0; if (y0>y4) y4=y0;
			if (z0<z3) z3=z0; if (z0>z4) z4=z0;
		    }
		    if (x1<x3) x3=x1; if (x1>x4) x4=x1;
		    if (y1<y3) y3=y1; if (y1>y4) y4=y1;
		    if (z1<z3) z3=z1; if (z1>z4) z4=z1;
		    if (x2<x3) x3=x2; if (x2>x4) x4=x2;
		    if (y2<y3) y3=y2; if (y2>y4) y4=y2;
		    if (z2<z3) z3=z2; if (z2>z4) z4=z2;
		}
		printf("%s\t%d\t%f\t%f\t%f\t%f\t%f\t%f\n",
		       *argv,num,x3,y3,z3,x4,y4,z4);
	    }
	    if (file!=stdin) fclose(file);
	}
	return 0;
}
