
#ifndef	STL_COLOR
#define STL_COLOR
#endif

#include <stdio.h>
#include <stdlib.h>
#include "stl.h"

static void	Abort(path,msg)
char		*path,*msg;
{
	fprintf(stderr,"%s : %s.\n",path,msg); exit(1);
}

#define BYTE	unsigned char

static void	PutNormal(ptr,file)
BYTE		*ptr;
FILE		*file;
{
	fwrite(ptr,4,1,file);
}

static void	PutReverse(ptr,file)
BYTE		*ptr;
FILE		*file;
{
fputc(ptr[3],file); fputc(ptr[2],file); fputc(ptr[1],file); fputc(ptr[0],file);
}

#define ORG		argv[1]
#define NEW		argv[argc-1]
#define NUM		stl.u.b.num
#define PUT(ptr,file)	(*Put)((BYTE *)ptr,file)

int	main(argc,argv)
int	argc;
char	**argv;
{
	FILE	*org=stdin,*new=stdout;
	STL	stl;
	int	num,cnt,r=255,g=255,b=255;
	float	x0,y0,z0,x1,y1,z1,x2,y2,z2;
	short	cf,s=0x1234;
	BYTE	rgb[3],*c=(BYTE *)&s;
	void	(*Put)()=(*c==(BYTE)(s&0xff))?PutReverse:PutNormal;

	if (argc!=3 && argc!=6) {
	    fputs("usage : stl_ply STL {R G B} PLY\n",stderr); exit(1);
	}
	if (ORG[0]!='-')
	    if ((org=fopen(ORG,"rb"))==NULL) Abort(ORG,"file not found");

	if (!SetUpSTL(&stl,org)) Abort(ORG,"STL header read error");

	if (stl.type!=STL_TYPE_BINARY) Abort(ORG,"not a binary STL");

	if (argc==6)
	    if ((r=atoi(argv[2]))<0 || r>255 ||
		(g=atoi(argv[3]))<0 || g>255 ||
		(b=atoi(argv[4]))<0 || b>255) {
		fputs("bad surface color.\n",stderr); exit(1);
	    }

	if (NEW[0]!='-')
	    if ((new=fopen(NEW,"wb"))==NULL) Abort(NEW,"file not stored");

	fprintf(new,"ply\n"
		    "format binary_big_endian 1.0\n"
		    "element vertex %d\n"
		    "property float x\n"
		    "property float y\n"
		    "property float z\n"
		    "property uchar red\n"
		    "property uchar green\n"
		    "property uchar blue\n"
		    "element face %d\n"
		    "property list uchar int vertex_indices\n"
		    "end_header\n",
		    num=NUM*3,NUM);

	for (cnt=0; cnt<num; cnt+=3) {
	    if (ScanSTL(&stl,&x0,&y0,&z0,&x1,&y1,&z1,&x2,&y2,&z2,&cf)<=0)
		Abort(ORG,"unexpected end of file");

	    if (STL_COLOR_FLAG(cf)) {
		rgb[0]=(BYTE)(STL_COLOR_R(cf)*255.0+0.5);
		rgb[1]=(BYTE)(STL_COLOR_G(cf)*255.0+0.5);
		rgb[2]=(BYTE)(STL_COLOR_B(cf)*255.0+0.5);
	    }
	    else {
		rgb[0]=(BYTE)r;
		rgb[1]=(BYTE)g;
		rgb[2]=(BYTE)b;
	    }
	    PUT(&x0,new); PUT(&y0,new); PUT(&z0,new); fwrite(rgb,3,1,new);
	    PUT(&x1,new); PUT(&y1,new); PUT(&z1,new); fwrite(rgb,3,1,new);
	    PUT(&x2,new); PUT(&y2,new); PUT(&z2,new); fwrite(rgb,3,1,new);
	}
	if (org!=stdin) fclose(org);

	for (cnt=0; cnt<num; ) {
	    fputc(3,new); PUT(&cnt,new); ++cnt;
			  PUT(&cnt,new); ++cnt;
			  PUT(&cnt,new); ++cnt;
	}
	if (new!=stdout) fclose(new);

	return 0;
}
