
#include <math.h>
#include "ph.h"

static Vertex	vertex[4]={
{ 0.0                    ,-0.942809041582063365868,-0.333333333333333333333},
{-0.816496580927726032732, 0.471404520791031682934,-0.333333333333333333333},
{ 0.816496580927726032732, 0.471404520791031682934,-0.333333333333333333333},
{ 0.0                    , 0.0                    , 1.0                    }};

void	RotatePolyhedron(lon,lat,rot)
double	lon,lat,rot;
{
	Vertex	V,*v=vertex+4;
	double	l=lon*M_PI/180.0,sl=sin(l),cl=cos(l),
		p=lat*M_PI/180.0,sp=sin(p),cp=cos(p),
		t=rot*M_PI/180.0,st=sin(t),ct=cos(t),
		xX=  sl*ct+cl*sp*st,xY= -sl*st+cl*sp*ct,xZ=cl*cp,
		yX= -cl*ct+sl*sp*st,yY=  cl*st+sl*sp*ct,yZ=sl*cp,
		zX=          -cp*st,zY=          -cp*ct,zZ=   sp;

	while (--v>=vertex) {
	    V=(*v); v->x=xX*V.x-xY*V.y-xZ*V.z;
		    v->y=yX*V.x-yY*V.y-yZ*V.z;
		    v->z=zX*V.x-zY*V.y-zZ*V.z;
	}
}

static Trigon	trigon[4]={{vertex+0,vertex+1,vertex+2},
			   {vertex+0,vertex+2,vertex+3},
			   {vertex+0,vertex+3,vertex+1},
			   {vertex+1,vertex+3,vertex+2}};

int	Polyhedron(ptr)
Trigon	**ptr;
{
	*ptr=trigon; return 4;
}
