
#include <stdio.h>
#include <stdlib.h>
#include <string.h>	/* using strcmp() */

static void	Error(char *msg)
{
	(void)fputs(msg,stderr); (void)fputc('\n',stderr); exit(1);
}

static int	Normal4(char *ptr,FILE *file)
{
	return fread(ptr,(size_t)4,(size_t)1,file)==1;
}

static int	Reverse4(char *ptr,FILE *file)
{
	return fread(ptr+3,(size_t)1,(size_t)1,file)==1 &&
	       fread(ptr+2,(size_t)1,(size_t)1,file)==1 &&
	       fread(ptr+1,(size_t)1,(size_t)1,file)==1 &&
	       fread(ptr+0,(size_t)1,(size_t)1,file)==1;
}

#define WORD	unsigned int
#define BYTE	unsigned char

int	main(int argc,char **argv)
{
	FILE	*file;
	WORD	V,F,*I,v,f,v0,v1,v2,c,i,word=255;
	char	e_h[12];
	BYTE	*R,*G,*B,*byte=(BYTE *)&word;
	int	(*Fread4)()=(*byte==(BYTE)(word&255))?Normal4:Reverse4;
	float	x,y,z;

	if (argc!=2) Error("usage : zcp2vrml2 ZCP");

	if (argv[1][0]=='-')
	    file=stdin;
	else
	    if ((file=fopen(argv[1],"rb"))==NULL) Error("file not found.");

	if (fscanf(file,"ply\n"
			"format binary_little_endian 1.0\n"
			"element vertex %u\n"
			"property float x\n"
			"property float y\n"
			"property float z\n"
			"element face %u\n"
			"property uchar red\n"
			"property uchar green\n"
			"property uchar blue\n"
			"property list uchar int vertex_indices\n",&V,&F)!=2 ||
	    fgets(e_h,12,file)==NULL || strcmp(e_h,"end_header\n") ||
	    V==0 || F==0) Error("bad header.");

	if ((I=(WORD *)malloc(sizeof(*I)*(size_t)(256*256*256)))==NULL ||
	    (R=(BYTE *)malloc((size_t)F))==NULL ||
	    (G=(BYTE *)malloc((size_t)F))==NULL ||
	    (B=(BYTE *)malloc((size_t)F))==NULL)
	    Error("memory allocation error.");

	(void)puts("#VRML V2.0 utf8\n"
		   "Shape {\n"
		   "geometry IndexedFaceSet {\n"
		   "colorPerVertex FALSE\n"
		   "coord Coordinate {\npoint [");

	for (v=0; v<V; v++) {
	    if (!(*Fread4)((char *)&x,file) ||
		!(*Fread4)((char *)&y,file) ||
		!(*Fread4)((char *)&z,file)) Error("bad vertex.");

	    (void)printf("%f %f %f\n",x,y,z);
	}
	(void)puts("]\n}\n"
		   "coordIndex [");

	for (c=0; c<256*256*256; c++) I[c]=F;

#define C(r,g,b)	((WORD)(r)<<16)|((WORD)(g)<<8)|(WORD)(b)

	for (i=f=0; f<F; f++) {
	    if (fread(R+f,(size_t)1,(size_t)1,file)!=1 ||
		fread(G+f,(size_t)1,(size_t)1,file)!=1 ||
		fread(B+f,(size_t)1,(size_t)1,file)!=1 ||
		fgetc(file)!=3 ||
		!(*Fread4)((char *)&v0,file) || v0>=V ||
		!(*Fread4)((char *)&v1,file) || v1>=V ||
		!(*Fread4)((char *)&v2,file) || v2>=V) Error("bad face.");

	    if (I[c=C(R[f],G[f],B[f])]==F) I[c]=i++;

	    (void)printf("%u %u %u -1\n",v0,v1,v2);
	}
	(void)puts("]\n"
		   "color Color {\ncolor [");

	for (i=f=0; f<F; f++)
	    if (I[C(R[f],G[f],B[f])]==i) {
		++i; (void)printf("%g %g %g\n",(float)R[f]/255.0,
					       (float)G[f]/255.0,
					       (float)B[f]/255.0);
	    }

	(void)puts("]\n}\n"
		   "colorIndex [");

	for (f=0; f<F; f++) (void)printf("%u\n",I[C(R[f],G[f],B[f])]);

	(void)puts("]\n}\n"
		   "appearance Appearance {\nmaterial Material {}\n}\n"
		   "}");
	return 0;
}
