
#include <stdio.h>
#include <stdlib.h>
#include <string.h>	/* using strcmp() */

static void	Error(char *msg)
{
	(void)fputs(msg,stderr); (void)fputc('\n',stderr); exit(1);
}

static int	Normal4(char *ptr,FILE *file)
{
	return fread(ptr,(size_t)4,(size_t)1,file)==1;
}

static int	Reverse4(char *ptr,FILE *file)
{
	return fread(ptr+3,(size_t)1,(size_t)1,file)==1 &&
	       fread(ptr+2,(size_t)1,(size_t)1,file)==1 &&
	       fread(ptr+1,(size_t)1,(size_t)1,file)==1 &&
	       fread(ptr+0,(size_t)1,(size_t)1,file)==1;
}

#define WORD	unsigned int
#define BYTE	unsigned char
#define PRINTF	(void)printf

int	main(int argc,char **argv)
{
	FILE	*file;
	WORD	V,F,v,f,v0,v1,v2,word=255;
	char	e_h[12];
	float	x,y,z;
	BYTE	R,G,B,*byte=(BYTE *)&word;
	int	(*Fread4)()=(*byte==(BYTE)(word&255))?Normal4:Reverse4;

	if (argc!=2) Error("usage : zcp_dmp ZCP");

	if (argv[1][0]=='-')
	    file=stdin;
	else
	    if ((file=fopen(argv[1],"rb"))==NULL) Error("file not found.");

	if (fscanf(file,"ply\n"
			"format binary_little_endian 1.0\n"
			"element vertex %u\n"
			"property float x\n"
			"property float y\n"
			"property float z\n"
			"element face %u\n"
			"property uchar red\n"
			"property uchar green\n"
			"property uchar blue\n"
			"property list uchar int vertex_indices\n",&V,&F)!=2 ||
	    fgets(e_h,12,file)==NULL || strcmp(e_h,"end_header\n") ||
	    V==0 || F==0) Error("bad header.");

	PRINTF("%u\t%u\n",V,F);

	for (v=0; v<V; v++) {
	    if (!(*Fread4)((char *)&x,file) ||
		!(*Fread4)((char *)&y,file) ||
		!(*Fread4)((char *)&z,file)) Error("bad vertex.");

	    PRINTF("%f\t%f\t%f\n",x,y,z);
	}
	for (f=0; f<F; f++) {
	    if (fread(&R,(size_t)1,(size_t)1,file)!=1 ||
		fread(&G,(size_t)1,(size_t)1,file)!=1 ||
		fread(&B,(size_t)1,(size_t)1,file)!=1 ||
		fgetc(file)!=3 ||
		!(*Fread4)((char *)&v0,file) || v0>=V ||
		!(*Fread4)((char *)&v1,file) || v1>=V ||
		!(*Fread4)((char *)&v2,file) || v2>=V) Error("bad face.");

	    PRINTF("%u\t%u\t%u\t%d\t%d\t%d\n",v0,v1,v2,(int)R,(int)G,(int)B);
	}
	return 0;
}
